package cn.com.tenlion.systembase.service.stuteasafe;

import cn.com.tenlion.systembase.pojo.bos.stuteasafe.StuTeaSafeBO;
import cn.com.tenlion.systembase.pojo.dtos.stuteasafe.StuTeaSafeDTO;
import cn.com.tenlion.systembase.pojo.pos.stuteasafe.StuTeaSafePO;
import cn.com.tenlion.systembase.pojo.vos.stuteasafe.StuTeaSafeVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IStuTeaSafeService
 * @Description: 涉及师生安全的案（事）件
 * @Author: CodeFactory
 * @Date: 2021-10-13 11:08:57
 * @Version: 3.0
 **/
public interface IStuTeaSafeService {

    /**
     * 新增涉及师生安全的案（事）件
     *
     * @param stuTeaSafeVO
     * @return
     */
    void save(StuTeaSafeVO stuTeaSafeVO);

    /**
     * 新增涉及师生安全的案（事）件
     *
     * @param token
     * @param stuTeaSafeVO
     * @return
     */
    void save(String token, StuTeaSafeVO stuTeaSafeVO);

    /**
     * 新增涉及师生安全的案（事）件
     *
     * @param stuTeaSafeVO
     * @return stuTeaSafeId
     */
    String saveReturnId(StuTeaSafeVO stuTeaSafeVO);

    /**
     * 新增涉及师生安全的案（事）件
     *
     * @param token
     * @param stuTeaSafeVO
     * @return stuTeaSafeId
     */
    String saveReturnId(String token, StuTeaSafeVO stuTeaSafeVO);

    /**
     * 删除涉及师生安全的案（事）件
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除涉及师生安全的案（事）件
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除涉及师生安全的案（事）件（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改涉及师生安全的案（事）件
     *
     * @param stuTeaSafeId
     * @param stuTeaSafeVO
     * @return
     */
    void update(String stuTeaSafeId, StuTeaSafeVO stuTeaSafeVO);

    /**
     * 修改涉及师生安全的案（事）件
     *
     * @param token
     * @param stuTeaSafeId
     * @param stuTeaSafeVO
     * @return
     */
    void update(String token, String stuTeaSafeId, StuTeaSafeVO stuTeaSafeVO);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    StuTeaSafeDTO get(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param stuTeaSafeId
     * @return
     */
    StuTeaSafeDTO get(String stuTeaSafeId);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    StuTeaSafeBO getBO(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param stuTeaSafeId
     * @return
     */
    StuTeaSafeBO getBO(String stuTeaSafeId);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param params 参数Map
     * @return
     */
    StuTeaSafePO getPO(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件详情
     *
     * @param stuTeaSafeId
     * @return
     */
    StuTeaSafePO getPO(String stuTeaSafeId);

    /**
     * 涉及师生安全的案（事）件列表
     *
     * @param params
     * @return
     */
    List<StuTeaSafeDTO> list(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件列表
     *
     * @param params
     * @return
     */
    List<StuTeaSafeBO> listBO(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件列表
     *
     * @param params
     * @return
     */
    List<StuTeaSafePO> listPO(Map<String, Object> params);

    /**
     * 涉及师生安全的案（事）件分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<StuTeaSafeDTO>> listPage(ListPage page);

    /**
     * 涉及师生安全的案（事）件统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, StuTeaSafeVO stuTeaSafeVO);

    void updateKafka(String uid, StuTeaSafeVO stuTeaSafeVO);

    void deleteKafka(String uid);

}